#gen_xls_data
# Python script which generates x vs y data in an Excel spreadsheet.
# LAST UPDATED by Andy French December 2017

#Import Python numeric, timing and plotting libraries
import numpy as Npy
import xlwt
import time

#

#Display welcome message to console
print(" Excel xls data generator")
print(" By Dr Andrew French. December 2017")
print("\n Generating Excel x,y data file Excel xy.xls")

#Generate a y = 3*sqrt(x) curve + some random noise
x0 = 0
xmax = 10
N = 100
x = Npy.linspace(x0,xmax,N)
yrand = 2*Npy.random.rand(1,N) - 1
y = 3*Npy.sqrt(x)
yrand = y + yrand[0]

#Initialize Excel workbook
book = xlwt.Workbook(encoding="utf-8")

#Add sheet to workbook
sheet1 = book.add_sheet("Python x vs y data")

#Top level heading
sheet1.write(0, 0, "Excel data generated from Python " + time.strftime('%X %x %Z'))

#Data headings
sheet1.write( 2, 0, "x" )
sheet1.write( 2, 1, "y" )
sheet1.write( 2, 2, "y + noise" )

#Add x,y data
for i in range(0,N):
    row = 3 + i
    sheet1.write(row, 0, x[i])
    sheet1.write(row, 1, y[i])
    sheet1.write(row, 2, yrand[i])

#Save Excel file
book.save("Excel xy.xls")

#Wait for user input to close terminal window
input("\n Press any key to continue ...")

#End of code
